//
// YellowMarker.jsx
// This script should be in the same folder as the document YellowMarkerSourceCSx.indd
// It is automatically called by the YellowMarkerController page item.
//

// ******* Main program

if (theItem.eventCode == "enableMenus")
{
  //
  // Return desired menu state via our tempDataStore property
  //
  theItem.tempDataStore = HaveSomeTextSelected(app.selection);
}
else if (theItem.eventCode == "menuYellowMarker" ||
  theItem.eventCode == "externalYellowMarker")
{
  var markerColor = GetMarkerColor();
  Mark(app.selection,markerColor);
}
else if (theItem.eventCode == "docLoaded" || theItem.eventCode == "selected")
{
  app.registerMenuItem("menuYellowMarker","Apply Yellow Marker");
}

// ******* Subroutines

function HaveSomeTextSelected(theSelection)
{
  var textSelected = false;
  if (theSelection instanceof Array)
  {
    var idx = 0;
    while (! textSelected && idx < theSelection.length)
    {
      textSelected = HaveSomeTextSelected(theSelection[idx]);
      idx++;
    }
  }
  else if 
  (
    theSelection instanceof Text
   ||
    theSelection instanceof Word
   ||
    theSelection instanceof Paragraph
   ||
    theSelection instanceof TextColumn
  )
  {
    textSelected = true;
  }
 
  return textSelected;
}

function Mark(theSelection, markerColor)
{
  if (theSelection instanceof Array)
  {
    for (var idx = 0; idx < theSelection.length; idx++)
    {
      Mark(theSelection[idx],markerColor);
    }
  }
  else if 
  (
    theSelection instanceof Text
   ||
    theSelection instanceof Word
   ||
    theSelection instanceof Paragraph
   ||
    theSelection instanceof TextColumn
  )
  {
    theSelection.underline = true;
    theSelection.underlineWeight = theSelection.pointSize;
    theSelection.underlineOffset = -theSelection.descent;
    theSelection.underlineColor = markerColor;
  }
}

function GetMarkerColor()
{
  var markerColor = app.activeDocument.swatches.item("MarkerYellow");
  var theErr;
  try
  {
   var name = markerColor.name;
  }
  catch (theErr)
  {
   markerColor = app.activeDocument.colors.add();
   markerColor.name = "MarkerYellow";
   markerColor.model = ColorModel.process;
   markerColor.space = ColorSpace.cmyk;
   markerColor.colorValue = [0, 0, 100, 0];
  }
  return markerColor;
}

